<?php

namespace Makecommerce\Ecommerce\Api\Data;

/**
 * Interface PaymentMethodInterface
 *
 * @category DataInterface
 * @package  Makecommerce\Ecommerce\Api\Data
 * @author   Maksekeskus AS <info@maksekeskus.ee>
 * @license  OSL-3.0 https://opensource.org/licenses/OSL-3.0
 */
interface PaymentMethodInterface
{
    /**#@+
     * Constants defined for keys of array, makes typos less likely
     */

    const NAME = 'name';

    const COUNTRY = 'country';

    const URL = 'url';

    /**#@-*/

    /**
     * Get name
     *
     * @return string
     */
    public function getName();

    /**
     * Get country code
     *
     * @return string|null
     */
    public function getCountry();

    /**
     * Get payment method url
     *
     * @return string|null
     */
    public function getUrl();

    /**
     * Set Name
     *
     * @param  string $name
     * @return \Makecommerce\Ecommerce\Api\Data\MethodInterface
     */
    public function setName($name);

    /**
     * Set country code
     *
     * @param  string|null $countryCode
     * @return \Makecommerce\Ecommerce\Api\Data\MethodInterface
     */
    public function setCountry($countryCode = null);

    /**
     * Set payment method url
     *
     * @param  string|null $url
     * @return \Makecommerce\Ecommerce\Api\Data\MethodInterface
     */
    public function setUrl($url = null);
}
